<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh/HowTos/php7</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh/HowTos/php7</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="A.2BVyg_CentOS_7.4_.2BTgpPf3Uo_PHP_7.x">在 CentOS 7.4 上使用 PHP 7.x</h1>
<span class="anchor" id="line-4"></span><p class="line874">此文章是关乎我近日所关注的一个问题：如何在 CentOS 7 缺省的 httpd 服务器上采用 PHP 7.0 或 7.1，却不采用外置软件库或从源码重新编译 PHP？ <span class="anchor" id="line-5"></span><span class="anchor" id="line-6"></span><p class="line862">答案是 <strong>软件选集</strong>。在这里我们会从新的 CentOS 安装开始，进而设立一个执行 PHP 7.x 的网站。 <span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><p class="line874">首先，我们会安装软件选集的软件库（它是一个需要启用的官方软件库）。 <span class="anchor" id="line-9"></span><span class="anchor" id="line-10"></span><p class="line867"><tt>root&nbsp;@&nbsp;centos7-vm:&nbsp;~&nbsp;#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;centos-release-scl.noarch</tt> <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><p class="line874">此指令会在你的系统上部署一个新的软件库，它是 CentOS 的其中一个官方软件库。 <span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line874">安装完成后，让我们安装 PHP 7 组件及 httpd 组件，连同它的插件。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line867"><tt>root&nbsp;@&nbsp;centos7-vm:&nbsp;~&nbsp;24&nbsp;#&nbsp;yum&nbsp;-y&nbsp;install&nbsp;rh-php72&nbsp;rh-php72-php&nbsp;rh-php72-php-fpm&nbsp;httpd</tt> <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line862">为了要采用 php 7.2，我们将会使用 php-fpm，这是 <a class="https" href="https://wiki.apache.org/httpd/php">推荐的做法</a>，并代替了 mod_php。既然如此，我们便采用 fpm 服务。此服务缺省会在 900 端口上运行。要是你需要更改端口号，请打开以下文件： <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867"><tt>/etc/opt/rh/rh-php72/php-fpm.d/www.conf</tt> <span class="anchor" id="line-21"></span><span class="anchor" id="line-22"></span><p class="line874">然后将下行修改： <span class="anchor" id="line-23"></span><span class="anchor" id="line-24"></span><p class="line867"><tt>listen&nbsp;=&nbsp;127.0.0.1:9000</tt> <span class="anchor" id="line-25"></span><span class="anchor" id="line-26"></span><p class="line874">成为你所需的设置（例如：9002）。完成后，我们必须更改 selinux 的数据库并加入 9002 为 httpd 服务的有效端口。 <span class="anchor" id="line-27"></span><span class="anchor" id="line-28"></span><p class="line867"><tt>semanage&nbsp;port&nbsp;-a&nbsp;-t&nbsp;http_port_t&nbsp;-p&nbsp;tcp&nbsp;9002</tt> <span class="anchor" id="line-29"></span><span class="anchor" id="line-30"></span><p class="line874">完成后，打开 php-fpm 服务并在开机时引导它： <span class="anchor" id="line-31"></span><span class="anchor" id="line-32"></span><p class="line874">{{{root @ centos7-vm: ~ 29 # systemctl enable rh-php72-php-fpm.service <span class="anchor" id="line-33"></span>Created symlink from /etc/systemd/system/multi-user.target.wants/rh-php72-php-fpm.service to /usr/lib/systemd/system/rh-php72-php-fpm.service. <span class="anchor" id="line-34"></span>root @ centos7-vm: ~ 30 # systemctl start rh-php72-php-fpm.service <span class="anchor" id="line-35"></span>root @ centos7-vm: ~ 31 # systemctl status rh-php72-php-fpm.service <span class="anchor" id="line-36"></span>● rh-php72-php-fpm.service - The PHP FastCGI Process Manager <span class="anchor" id="line-37"></span><ul><li style="list-style-type:none">Loaded: loaded (/usr/lib/systemd/system/rh-php72-php-fpm.service; enabled; vendor preset: disabled) <span class="anchor" id="line-38"></span>Active: active (running) since Thu 2019-11-07 01:04:34 UTC; 20min ago <span class="anchor" id="line-39"></span></li></ul><ul><li style="list-style-type:none">Main PID: 5202 (php-fpm) <span class="anchor" id="line-40"></span><ul><li style="list-style-type:none"><p class="line862">Status: &quot;Ready to handle connections&quot; <span class="anchor" id="line-41"></span>CGroup: /system.slice/rh-php72-php-fpm.service <span class="anchor" id="line-42"></span><ul><li style="list-style-type:none">├─30045 php-fpm: master process (/etc/opt/rh/rh-php72/php-fpm.conf) <span class="anchor" id="line-43"></span>├─30046 php-fpm: pool www <span class="anchor" id="line-44"></span>├─30047 php-fpm: pool www <span class="anchor" id="line-45"></span>├─30048 php-fpm: pool www <span class="anchor" id="line-46"></span>├─30049 php-fpm: pool www <span class="anchor" id="line-47"></span>└─30050 php-fpm: pool www}}} <span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span></li></ul></li></ul></li></ul><p class="line874">现在我们须要设置 httpd 后台服务并告欣它利用此服务来处理 php 页面。 <span class="anchor" id="line-50"></span><span class="anchor" id="line-51"></span><p class="line862">让我们在 <tt>/etc/httpd/conf.d/</tt> 数据来创建名为 <tt>fpm.conf</tt> 的文件，并放入以下内容： <span class="anchor" id="line-52"></span><span class="anchor" id="line-53"></span><p class="line874">{{{# PHP scripts setup <span class="anchor" id="line-54"></span><a class="nonexistent" href="./ProxyPassMatch.html">ProxyPassMatch</a> ^/(.*.php)$ fcgi://127.0.0.1:9000/var/www/html <span class="anchor" id="line-55"></span><span class="anchor" id="line-56"></span><p class="line874">Alias / /var/www/html/ <span class="anchor" id="line-57"></span><span class="anchor" id="line-58"></span><p class="line867"><a class="nonexistent" href="./DirectoryIndex.html">DirectoryIndex</a> index.php}}} <span class="anchor" id="line-59"></span><span class="anchor" id="line-60"></span><p class="line874">如此，apache 将会把所有以 .php 结尾的文件传送到我们的 php-fpm 服务，然后显示所得结果。 <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><p class="line874">为要确定一切正常，我们会在 /var/www/html 创建一个小页面，提出 phpinfo 的要求 <span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><p class="line874">{{{root @ centos7-vm: ~ 1 # cat /var/www/html/index.php <span class="anchor" id="line-65"></span>&lt;?php phpinfo() ?&gt; <span class="anchor" id="line-66"></span>root @ centos7-vm: ~ 1 #}}} <span class="anchor" id="line-67"></span><span class="anchor" id="line-68"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 切勿忘记这只是一个基本设置来确定你的安装能运作。如果你需要实际应用于程序中，你或许应参考 <a class="https" href="https://developers.redhat.com/blog/2017/10/25/php-configuration-tips/">此文章</a> 对准你的 php 设置。 <span class="anchor" id="line-69"></span><span class="anchor" id="line-70"></span><p class="line874">请勿忘记起动、启用及加入你的 httpd 服务到防火墙： <span class="anchor" id="line-71"></span><span class="anchor" id="line-72"></span><p class="line874">{{{root @ centos7-vm: ~ 43 # systemctl enable httpd ; systemctl start httpd <span class="anchor" id="line-73"></span>root @ centos7-vm: ~ 46 # firewall-cmd --add-service=http --permanent <span class="anchor" id="line-74"></span>success <span class="anchor" id="line-75"></span>root @ centos7-vm: ~ 47 # firewall-cmd --reload <span class="anchor" id="line-76"></span>success}}} <span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><p class="line874">现在我们若连接到该网站，它会显示 php 已被正确地处理： <span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><p class="line867"><img alt="HowTos/php7/phpinfo7.0.png" class="attachment" src="attachments/HowTos(2f)php7/phpinfo7.0.png" title="HowTos/php7/phpinfo7.0.png" /> <span class="anchor" id="line-81"></span><span class="anchor" id="line-82"></span><p class="line867"><small>Translation of revision 7</small> <span class="anchor" id="line-83"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
